"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const dependency_path_1 = require("dependency-path");
const fromPairs_1 = __importDefault(require("ramda/src/fromPairs"));
function extendProjectsWithTargetDirs(projects, lockfile, ctx) {
    const getLocalLocation = ctx.pkgLocationByDepPath != null
        ? (depPath) => ctx.pkgLocationByDepPath[depPath]
        : (depPath, pkgName) => path_1.default.join(ctx.virtualStoreDir, (0, dependency_path_1.depPathToFilename)(depPath), 'node_modules', pkgName);
    const projectsById = (0, fromPairs_1.default)(projects.map((project) => [project.id, { ...project, targetDirs: [] }]));
    Object.entries(lockfile.packages ?? {})
        .forEach(([depPath, pkg]) => {
        if (pkg.resolution?.['type'] !== 'directory')
            return;
        const pkgId = pkg.id ?? depPath;
        const importerId = pkgId.replace(/^file:/, '');
        if (projectsById[importerId] == null)
            return;
        const localLocation = getLocalLocation(depPath, pkg.name);
        projectsById[importerId].targetDirs.push(localLocation);
        projectsById[importerId].stages = ['preinstall', 'install', 'postinstall', 'prepare', 'prepublishOnly'];
    });
    return Object.values(projectsById);
}
exports.default = extendProjectsWithTargetDirs;
//# sourceMappingURL=extendProjectsWithTargetDirs.js.map